﻿Imports System.Threading
Public Class Form1

    Declare Auto Function SendMessage Lib "user32.dll" (ByVal hWnd As IntPtr, ByVal msg As Integer, _
    ByVal wParam As Integer, ByVal lParam As Integer) As Integer

    Private ThreadActive As Boolean = False

    Private Delegate Sub DelSetLabelNumber(n As String)
    Private Delegate Sub DelSetProgressbarValue(i As Integer)

    Private Sub SetProgressbarValue(i As Integer)
        Me.ProgressBar1.Value = i
    End Sub

    Private Sub SetLabelNumber(n As String)
        Me.Label1.Text = n
    End Sub

    Private Sub Form1_Disposed(sender As Object, e As System.EventArgs) Handles Me.Disposed
        ThreadActive = False
        End
    End Sub

    Private Sub Form1_load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Label1.Text = ""
        SendMessage(ProgressBar1.Handle, &H400 + 16, &H3, 0) 'Progressbar gelb

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Dim thread1 As New Thread(AddressOf CountUp)
        ThreadActive = True
        thread1.Start()
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        ThreadActive = False
    End Sub

    Sub CountUp()
        Dim pbvalue As Integer = 0
        Dim pbvalue2 As Integer = 0
        Dim myStep As Integer = 1
        Try
            For i As Integer = 0 To 1000
                If ThreadActive = False Then Exit For

                Dim delegateLabel As New DelSetLabelNumber(AddressOf SetLabelNumber)
                Dim delegateProgressbar As New DelSetProgressbarValue(AddressOf SetProgressbarValue)

                'Label hochzählen
                If Me.Label1.InvokeRequired Then
                    Me.Label1.Invoke(delegateLabel, New Object() {i.ToString})
                Else
                End If
                'Progressbar hochzählen
                pbvalue = pbvalue + 1
                If pbvalue > ProgressBar1.Maximum Then pbvalue = 0
                If Me.ProgressBar1.InvokeRequired Then
                    Me.ProgressBar1.Invoke(delegateProgressbar, New Object() {pbvalue})
                Else
                End If
                Threading.Thread.Sleep(50)
            Next
            ThreadActive = False
        Catch ex As ThreadStartException
            Thread.ResetAbort()
        End Try
    End Sub
End Class